TITAN_HGRIND_ID = "HGrind";


TITAN_HGRIND_CFG = { };

TITAN_HGRIND_KILLSTODAY = {};
TITAN_HGRIND_KILLSLIFETIME = {};

TITAN_HGRIND_LASTKILL = "";
TITAN_HGRIND_PLAYER = nil;
TITAN_HGRIND_VARSLOADED = false;
TITAN_HGRIND_PENDINGUPDATE = false;
TITAN_HGRIND_LASTWIN_TIMESTAMP = 0;

TITAN_HGRIND_LastEstimated = 0;
TITAN_HGRIND_InBattleground = false;
TITAN_HGRIND_Map = "dummy";
--TITAN_HGRIND_OldMap = "";
TITAN_HGRIND_EnterTime = 0;
TITAN_HGRIND_BGCONFIRM = 0;

--UIDROPDOWNMENU_MENU_VALUE = "Addons_Information";

TITAN_MEMORY_MENU_TOGGLE_TABLE = {
	"AutoAcceptInvite",
	"AutoJoinBG",
	"AutoReleaseBG",
	"ChatSpamOnKill"
}

function TitanPanelHGrindButton_OnLoad()

	this.registry = {
		id = TITAN_HGRIND_ID,
		builtIn = 1,
		version = 0.99,
		category = "Information",
		menuText = "HonorGrind",
		buttonTextFunction = "TitanPanelHGrindButton_GetButtonText", 
		tooltipTitle ="HonorGrind 0.99 [RC1]",
		frequency = 1,
		tooltipTextFunction = "TitanPanelHGrindButton_GetTooltipText", 
		savedVariables = {
			AutoAcceptInvite = 1,
			AutoJoinBG = 1,
			AutoReleaseBG = 1,
			ChatSpamOnKill = 1
		}
	};	

	old_StaticPopup_OnHide = StaticPopup_OnHide;
	StaticPopup_OnHide = TitanPanelHGrindButton_StaticPopup_OnHide;
	
 	this:RegisterEvent("PLAYER_LEAVING_WORLD");
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("CHAT_MSG_COMBAT_HONOR_GAIN");
	this:RegisterEvent("PARTY_INVITE_REQUEST");
	this:RegisterEvent("UPDATE_BATTLEFIELD_STATUS");
	this:RegisterEvent("PLAYER_DEAD");
	--this:RegisterEvent("CONFIRM_BATTLEFIELD_ENTRY");
	
end

function TitanPanelHGrindButton_OnEvent()
	local autoAcceptInvite = TitanGetVar(TITAN_HGRIND_ID, "AutoAcceptInvite");
	local autoReleaseBG = TitanGetVar(TITAN_HGRIND_ID, "AutoReleaseBG");
	local chatSpamOnKill = TitanGetVar(TITAN_HGRIND_ID, "ChatSpamOnKill");
		
	
	if (event == "PLAYER_ENTERING_WORLD") then
		
		if (TITAN_HGRIND_VARSLOADED) then
			TitanPanelHGrindButton_GetPlayerName();
		else
			TITAN_HGRIND_PENDINGUPDATE = true;
		end

		local elapsed, gained;
		
		-- was last Zone AV, WS or AB?
		if (	TITAN_HGRIND_Map == TITAN_HGRIND_BG_AV or 
			TITAN_HGRIND_Map == TITAN_HGRIND_BG_AB or
			TITAN_HGRIND_Map == TITAN_HGRIND_BG_WS) 	then
		
		-- create and save stats for last Battleground --
		-- ------------------------------------------- --
			gained = math.floor(TITAN_HGRIND_CFG[TITAN_HGRIND_PLAYER].estCP - TITAN_HGRIND_LastEstimated);
			elapsed = math.floor( (time() - TITAN_HGRIND_EnterTime) / 60 );

			local tmp_gained;

			tmp_gained = gained;

			if (gained < 0) then
				gained = "?";
				tmp_gained = "unknown (daily reset possible).";
			end
			
			if (elapsed > 1 and gained ~= "?") then
				if (not TITAN_HGRIND_CFG[TITAN_HGRIND_PLAYER].BGHonorHistory[TITAN_HGRIND_Map]) then
					TITAN_HGRIND_CFG[TITAN_HGRIND_PLAYER].BGHonorHistory[TITAN_HGRIND_Map] = {};
				end

				table.insert(TITAN_HGRIND_CFG[TITAN_HGRIND_PLAYER].BGHonorHistory[TITAN_HGRIND_Map], { honor = gained, time = elapsed } );
				if (table.getn(TITAN_HGRIND_CFG[TITAN_HGRIND_PLAYER].BGHonorHistory[TITAN_HGRIND_Map]) > 10) then
					table.remove(TITAN_HGRIND_CFG[TITAN_HGRIND_PLAYER].BGHonorHistory[TITAN_HGRIND_Map], 1);
				end
			end
			
			-- saving stats successfull --
			DEFAULT_CHAT_FRAME:AddMessage("[ "..TITAN_HGRIND_Map..": "..gained..TITAN_HGRIND_H.." in "..elapsed.."min ]");	
						
		end

		-- check, if we are acutally in a Battleground --
		-- ------------------------------------------- --
		local i, id, map;
		TITAN_HGRIND_InBattleground = false;
		for i=1, 4 do
			_, map, id = GetBattlefieldStatus(i);
			if (id ~= 0) then   -- ZIOMG, we really are! --
				TITAN_HGRIND_Map = map; -- where are we?
				TITAN_HGRIND_LastEstimated = TITAN_HGRIND_CFG[TITAN_HGRIND_PLAYER].estCP; -- only count honor gained here!
				TITAN_HGRIND_EnterTime = time(); -- OMG IT'S CAPSLOCK TIME!
				--DEFAULT_CHAT_FRAME:AddMessage("Ready to count some honor, Baby!");
				TITAN_HGRIND_InBattleground = true; -- Remember, we are in a BG!
				break -- walk on with other events. Work done here!
			else
				TITAN_HGRIND_EnterTime = 0;
				TITAN_HGRIND_Map = "dummy";
				--DEFAULT_CHAT_FRAME:AddMessage("WTF, not in a BG? You'll never get your Rank14 Equip!");
			end
		end	
		
	
	elseif (event == "PARTY_INVITE_REQUEST" and autoAcceptInvite) then
		AcceptGroup();
		StaticPopup_Hide("PARTY_INVITE");
	
	elseif (event == "UPDATE_BATTLEFIELD_STATUS") then
		TitanPanelHGrindButton_CheckBGConfirm();

	elseif (event == "PLAYER_DEAD") then
		-- Auto-Release upon death. But not when soulstoned, and only in battlegrounds.
		local status;
		for i=1, MAX_BATTLEFIELD_QUEUES do
			local s, _, _ = GetBattlefieldStatus(i);
			if (s == "active") then
				status = "active";
				break;
			end
		end

		if ((status == "active") and (not HasSoulstone()) and autoReleaseBG) then
			RepopMe();
		end
		

	elseif (event == "CHAT_MSG_COMBAT_HONOR_GAIN") then
		local rank, ecp, est;

		_, _, TITAN_HGRIND_LASTKILL, rank, ecp = string.find(arg1, TITAN_HGRIND_HONORKILL);
		

		if (not TITAN_HGRIND_LASTKILL) then

			_, _, TITAN_HGRIND_LASTKILL = string.find(arg1, TITAN_HGRIND_HONORGAIN);
			if (TITAN_HGRIND_LASTKILL) then
				TITAN_HGRIND_CFG[TITAN_HGRIND_PLAYER].estCP = TITAN_HGRIND_CFG[TITAN_HGRIND_PLAYER].estCP + tonumber(TITAN_HGRIND_LASTKILL);
			end

		else

			if (not TITAN_HGRIND_KILLSTODAY[TITAN_HGRIND_PLAYER][TITAN_HGRIND_LASTKILL]) then
				TITAN_HGRIND_KILLSTODAY[TITAN_HGRIND_PLAYER][TITAN_HGRIND_LASTKILL] = 0;
			end

			TITAN_HGRIND_KILLSTODAY[TITAN_HGRIND_PLAYER][TITAN_HGRIND_LASTKILL] = TITAN_HGRIND_KILLSTODAY[TITAN_HGRIND_PLAYER][TITAN_HGRIND_LASTKILL] + 1;

			if (ecp) then
				est = TitanPanelHGrindButton_EstimateCP(ecp);

				TITAN_HGRIND_CFG[TITAN_HGRIND_PLAYER].estCP = TITAN_HGRIND_CFG[TITAN_HGRIND_PLAYER].estCP + est;
			end

			-- uncomment for debugging-mode
			if (chatSpamOnKill) then
				DEFAULT_CHAT_FRAME:AddMessage("[ "..TITAN_HGRIND_HK1..": "..TITAN_HGRIND_LASTKILL.." ("..TITAN_HGRIND_TODAY..": "..TITAN_HGRIND_KILLSTODAY[TITAN_HGRIND_PLAYER][TITAN_HGRIND_LASTKILL].." "..TITAN_HGRIND_TIMES..")  "..TITAN_HGRIND_ESTH..": "..math.floor(est).." ]");
			end
		end

	elseif (event == "VARIABLES_LOADED") then
		TITAN_HGRIND_VARSLOADED = true;
		if (TITAN_HGRIND_PENDINGUPDATE) then
			TitanPanelHGrindButton_GetPlayerName();
		end
	
	end

	TitanPanelButton_UpdateButton(TITAN_HGRIND_ID);		
end

function TitanPanelHGrindButton_OnClick(button)

end

function TitanPanelHGrindButton_GetButtonText(id)
	
	if(not TITAN_HGRIND_PLAYER) then
		return format("(Loading...)", TitanUtils_GetHighlightText(0), TitanUtils_GetGreenText(0));
	end

	TitanPanelHGrindButton_CheckBGConfirm();
	
	local txt, gained = 0;
	txt = "";
	txt2 = "";
	txt3 = "";
	if (TITAN_HGRIND_InBattleground) then
		gained = math.floor(TITAN_HGRIND_CFG[TITAN_HGRIND_PLAYER].estCP - TITAN_HGRIND_LastEstimated);
		
		txt3 = " in "..math.floor( (time() - TITAN_HGRIND_EnterTime) / 60 ).." min";
		txt2 = "This BG:";
		txt = gained;
		
	end

	cp = math.floor(TITAN_HGRIND_CFG[TITAN_HGRIND_PLAYER].estCP);

	Text = format(TITAN_HGRIND_H..": %s "..txt2.." %s"..txt3, TitanUtils_GetHighlightText(cp), TitanUtils_GetGreenText(txt));

	return Text;
end

function TitanPanelHGrindButton_GetTooltipText()
	local txt, hk, hc, ac, z;
	hk = GetPVPLifetimeStats();
	hc = GetHonorCurrency();
	ac = GetArenaCurrency();
	
	z = 0;
	for _ in pairs(TITAN_HGRIND_KILLSTODAY[TITAN_HGRIND_PLAYER]) do
		z = z + 1;
	end

	-- BG stats
	local bg, honorArr, avgHonor, avgTime, bgSession, dataPoints, bgstats;

	bgstats = "";

	
	for bg, honorArr in pairs(TITAN_HGRIND_CFG[TITAN_HGRIND_PLAYER].BGHonorHistory) do
		avgHonor = 0;
		avgTime = 0;

		dataPoints = table.getn(honorArr);
		
		for _, bgSession in pairs(honorArr) do
			avgHonor = avgHonor + bgSession.honor;
			avgTime = avgTime + bgSession.time;
		end
	
		avgHonor = math.floor(avgHonor / dataPoints);
		avgTime = math.floor(avgTime / dataPoints);

		bgstats =	bgstats.."\n"..TitanUtils_GetHighlightText(bg.." stats:").."\n"..
				TITAN_HGRIND_AVEH..": \t"..TitanUtils_GetHighlightText(avgHonor).."\n"..
				TITAN_HGRIND_AVET..": \t"..TitanUtils_GetHighlightText(avgTime).."\n"..
				TITAN_HGRIND_AVEHPH..": \t"..TitanUtils_GetHighlightText(math.floor((avgHonor/avgTime)*60)).."\n"..
				"";



	end


	local txt, gained = 0;
	txt = "";
	if (TITAN_HGRIND_InBattleground) then
		gained = math.floor(TITAN_HGRIND_CFG[TITAN_HGRIND_PLAYER].estCP - TITAN_HGRIND_LastEstimated);
		txt =	"\n"..TitanUtils_GetHighlightText(TITAN_HGRIND_CURRBG..": ").."\n"..
			TITAN_HGRIND_HGSF..": \t"..TitanUtils_GetHighlightText(gained);
	end




	return ""..
		TitanUtils_GetHighlightText(TITAN_HGRIND_CURRENCY..": ").."\n"..
		TITAN_HGRIND_HP..": \t"..TitanUtils_GetHighlightText(hc).."\n"..
	-- uncomment on BC
	--	"Arena points: \t"..TitanUtils_GetHighlightText(ac).."\n"..
		"\n"..
		
		TitanUtils_GetHighlightText(TITAN_HGRIND_TODAY..": ").."\n"..
		TITAN_HGRIND_HK..": \t"..TitanUtils_GetGreenText(z).."\n"..
		TITAN_HGRIND_HE..": \t"..TitanUtils_GetHighlightText(math.floor(TITAN_HGRIND_CFG[TITAN_HGRIND_PLAYER].estCP)).."\n"..



		bgstats..txt..


	"";



end

function TitanPanelRightClickMenu_PrepareHGrindMenu()
	TitanPanelRightClickMenu_AddTitle(TitanPlugins[TITAN_HGRIND_ID].menuText);

	
	TitanPanelRightClickMenu_AddSpacer();
  	TitanPanelRightClickMenu_AddToggleVar(TITAN_HGRIND_AAPI, TITAN_HGRIND_ID , "AutoAcceptInvite" );
	TitanPanelRightClickMenu_AddToggleVar(TITAN_HGRIND_AJBG, TITAN_HGRIND_ID , "AutoJoinBG" );
	TitanPanelRightClickMenu_AddToggleVar(TITAN_HGRIND_ARC, TITAN_HGRIND_ID , "AutoReleaseBG" );
	TitanPanelRightClickMenu_AddToggleVar(TITAN_HGRIND_CSOK, TITAN_HGRIND_ID , "ChatSpamOnKill" );

	
	TitanPanelRightClickMenu_AddSpacer();
	TitanPanelRightClickMenu_AddCommand(TITAN_HGRIND_RESET, TITAN_HGRIND_ID , "TitanPanelHGrindButton_ResetBGStats");
	
	
	TitanPanelRightClickMenu_AddSpacer();	
	TitanPanelRightClickMenu_AddCommand(TITAN_PANEL_MENU_HIDE, TITAN_HGRIND_ID, TITAN_PANEL_MENU_FUNC_HIDE);
end

function TitanPanelHGrindButton_ResetBGStats()

	TITAN_HGRIND_CFG[TITAN_HGRIND_PLAYER].BGHonorHistory = { };

end
	

function TitanPanelHGrindButton_GetPlayerName()
	local pname;

	pname = UnitName("player");
	if (pname and pname ~= UNKNOWNOBJECT and pname ~= UKNOWNBEING and pname ~= "Unknown Entity") then
		TitanPanelHGrindButton_Login();
	end
end


function TitanPanelHGrindButton_Login()

	TITAN_HGRIND_PLAYER = UnitName("player").." "..GetCVar("realmName");

	-- new player?
	if (not TITAN_HGRIND_KILLSLIFETIME[TITAN_HGRIND_PLAYER]) then
		TITAN_HGRIND_CFG[TITAN_HGRIND_PLAYER] = { yesterdayHK = 0, yesterdayCP = 0};
		TITAN_HGRIND_KILLSLIFETIME[TITAN_HGRIND_PLAYER] = { logined = 1 };
		TITAN_HGRIND_KILLSTODAY[TITAN_HGRIND_PLAYER] = {};
	end


	if (not TITAN_HGRIND_CFG[TITAN_HGRIND_PLAYER].estCP) then
		TITAN_HGRIND_CFG[TITAN_HGRIND_PLAYER].estCP = 0;
	end


	if (not TITAN_HGRIND_CFG[TITAN_HGRIND_PLAYER].BGHonorHistory) then
		TITAN_HGRIND_CFG[TITAN_HGRIND_PLAYER].BGHonorHistory = {};
	end

	-- check for new day, reset if it is
	TitanPanelHGrindButton_ResetToday();

end

function TitanPanelHGrindButton_ResetToday()
	local hk, contribution;

	-- Yesterday's values
	hk, contribution = GetPVPYesterdayStats();

	-- if yesterday's values differ from when last logged in, wipe kills for today
	if (	TITAN_HGRIND_CFG[TITAN_HGRIND_PLAYER].yesterdayHK ~= hk or
		TITAN_HGRIND_CFG[TITAN_HGRIND_PLAYER].yesterdayCP ~= contribution
	) then
		-- new day
		TITAN_HGRIND_CFG[TITAN_HGRIND_PLAYER].yesterdayHK = hk;
		TITAN_HGRIND_CFG[TITAN_HGRIND_PLAYER].yesterdayCP = contribution;

		TITAN_HGRIND_KILLSTODAY[TITAN_HGRIND_PLAYER] = {};

		-- wipe estinated CP for today
		TITAN_HGRIND_CFG[TITAN_HGRIND_PLAYER].estCP = 0;
		
	end
end

function TitanPanelHGrindButton_EstimateCP(ecp)
	if (TITAN_HGRIND_KILLSTODAY[TITAN_HGRIND_PLAYER][TITAN_HGRIND_LASTKILL] > 10) then
		return 0
	elseif (TITAN_HGRIND_KILLSTODAY[TITAN_HGRIND_PLAYER][TITAN_HGRIND_LASTKILL] == 1) then
		return ecp
	else
		return ecp - ( (TITAN_HGRIND_KILLSTODAY[TITAN_HGRIND_PLAYER][TITAN_HGRIND_LASTKILL] - 1) / 10 * ecp );
	end
end

function TitanPanelHGrindButton_CheckBGConfirm()
	local status, index;
	local autoJoin = TitanGetVar(TITAN_HGRIND_ID, "AutoJoinBG");

	for i=1,4 do
		status,_,_ = GetBattlefieldStatus(i);
		if(status == "confirm") then
			index = i;
			--DEFAULT_CHAT_FRAME:AddMessage(status.." "..index);
			break
		end
	end
	
	if (math.floor(TITAN_HGRIND_BGCONFIRM - GetTime()) == 19) then DEFAULT_CHAT_FRAME:AddMessage("20...", 1, 1, 0) end
	if (math.floor(TITAN_HGRIND_BGCONFIRM - GetTime()) == 9) then DEFAULT_CHAT_FRAME:AddMessage("10...", 1, 1, 0) end
	if (math.floor(TITAN_HGRIND_BGCONFIRM - GetTime()) == 4) then DEFAULT_CHAT_FRAME:AddMessage("5...", 1, 1, 0) end
	if (math.floor(TITAN_HGRIND_BGCONFIRM - GetTime()) == 3) then DEFAULT_CHAT_FRAME:AddMessage("4...", 1, 1, 0) end
	if (math.floor(TITAN_HGRIND_BGCONFIRM - GetTime()) == 2) then DEFAULT_CHAT_FRAME:AddMessage("3...", 1, 1, 0) end
	if (math.floor(TITAN_HGRIND_BGCONFIRM - GetTime()) == 1) then DEFAULT_CHAT_FRAME:AddMessage("2...", 1, 1, 0) end
	if (math.floor(TITAN_HGRIND_BGCONFIRM - GetTime()) == 0) then DEFAULT_CHAT_FRAME:AddMessage("1...", 1, 1, 0) end
		
	
	if ((status == "confirm") and (autoJoin == 1)) then
		if (StaticPopup_Visible("CONFIRM_BATTLEFIELD_ENTRY")) then
			if (TITAN_HGRIND_BGCONFIRM == 0) then
				DEFAULT_CHAT_FRAME:AddMessage(TITAN_HGRIND_MAJ, 1, 1, 0);
				TITAN_HGRIND_BGCONFIRM = GetTime() + 30;
			elseif (GetTime() > TITAN_HGRIND_BGCONFIRM) then
				TITAN_HGRIND_BGCONFIRM = 0;
				DEFAULT_CHAT_FRAME:AddMessage(TITAN_HGRIND_MAJNOW, 1, 1, 0);
				AcceptBattlefieldPort(index,1)
				StaticPopup_Hide("CONFIRM_BATTLEFIELD_ENTRY");
			end
		end
	end
end

-- If the "Hide" button is clicked when ready to enter BG.
-- It means the user doesn't want to join, so we disable auto-join.
function TitanPanelHGrindButton_StaticPopup_OnHide()
	old_StaticPopup_OnHide();
	if (this.which == "CONFIRM_BATTLEFIELD_ENTRY") and (TITAN_HGRIND_BGCONFIRM ~= 0) then
		TITAN_HGRIND_BGCONFIRM = 0;
		DEFAULT_CHAT_FRAME:AddMessage(TITAN_HGRIND_MAJDIS, 1, 1, 0);
	end
end

